<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;


class NutriRecomendation extends CrudWithParameterBag {
    
    protected $dataSourceNameArray = array(
        'recomendacaoNutri'       => 'nutriRecomendation',
        'paraNoCashRecomendNutri' => 'paraNoCash_nutriRecomendation'
    );
    protected $parameterBagColumnsArray = array(
        'recomendacaoNutri'       => array('CDFILIAL', 'NRORG'),
        'paraNoCashRecomendNutri' => array('CDOPERADOR', 'NRORG')
    );
    
    public function __construct(Manager $dataSourceManager,$parameterBag) {
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function findNutriFilial(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['paraNoCashRecomendNutri'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['paraNoCashRecomendNutri'];
        parent::find($request, $response);
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $this->dataSourceName = $this->dataSourceNameArray['recomendacaoNutri'];
            $this->parameterBagColumns = $this->parameterBagColumnsArray['recomendacaoNutri'];
            self::saveWithoutNotification($request, $response);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function saveWithoutNotification(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            $nrPersistedRows = count($persistedRows);
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}