<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;

class TipoConsumidorRestricaoAliemtar{
    
    protected $entityManager;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

    public function getResult($conditions){
        $tipoClienteFilial = $this->tipoConsClienteFilial($conditions);
        if(count($tipoClienteFilial) == 0){
            $tipoConsCliente = $this->tipoConsCliente($conditions);
            if(count($tipoConsCliente) == 0){
                $tipoConsFilial = $this->tipoConsFilial($conditions);
                if(count($tipoConsFilial) == 0){
                    return $this->allConsCli($conditions);
                }else{
                    return $tipoConsFilial;
                }
            }else{
                return $tipoConsCliente;
            }
        }else{
            return $tipoClienteFilial;
        }
        return array();
    }
    
    private function tipoConsClienteFilial ($conditions){
        return $this->entityManager->getConnection()->fetchAll(self::qryTipoConsCliFili, $conditions);
    }
    
    private function tipoConsCliente ($conditions){
        return $this->entityManager->getConnection()->fetchAll(self::qryTipoConsCli, $conditions);
    }
    
    private function tipoConsFilial ($conditions){
        return $this->entityManager->getConnection()->fetchAll(self::qryTipoConsFili, $conditions);
    }
    
    private function allConsCli ($conditions){
        return $this->entityManager->getConnection()->fetchAll(self::qryTpCons, $conditions);
    }
    
    const qryTipoConsCliFili = "
        SELECT TC.CDTIPOCONS, TC.NMTIPOCONSCLI AS NMTIPOCONS
          FROM TIPOCONSCLI TC, TIPOCONSFILI TF, CLIENTE CL
         WHERE (TC.CDCLIENTE    = CL.CDCLIENTE)
         AND (CL.NRINSJURCLIE = :NRINSJURCLIE)
           AND (TC.CDTIPOCONS   = TF.CDTIPOCONS)
           AND (TF.CDFILIAL     = :CDFILIAL)
           AND (TF.NRORG = :NRORG)
         ORDER BY TC.CDTIPOCONS 
    ";
    
    const qryTipoConsCli = "
        SELECT TC.CDTIPOCONS, TC.NMTIPOCONSCLI AS NMTIPOCONS
          FROM TIPOCONSCLI TC, CLIENFILIAL CF, CLIENTE CL
         WHERE (TC.CDCLIENTE    = CL.CDCLIENTE)
           AND (CL.NRINSJURCLIE = :NRINSJURCLIE)
           AND (CF.CDCLIENTE    = TC.CDCLIENTE)
           AND (CF.CDFILIAL     = :CDFILIAL)
           AND (CF.NRORG     = :NRORG)
         ORDER BY TC.CDTIPOCONS
    ";
    
    const qryTipoConsFili = "
        SELECT TC.CDTIPOCONS, TC.NMTIPOCONS
      FROM TIPOCONS TC, TIPOCONSFILI TF
     WHERE (TC.CDTIPOCONS = TF.CDTIPOCONS)
       AND (TF.CDFILIAL   = :CDFILIAL)
       AND (TF.NRORG = :NRORG)
     ORDER BY TC.CDTIPOCONS
    ";
    
    const qryTpCons = "
        SELECT CDTIPOCONS, NMTIPOCONS
          FROM TIPOCONS
          WHERE NRORG = :NRORG
        ORDER BY CDTIPOCONS
    ";
}